/******************************************************\
* (c)migaco       ecam@aon.at 						  *
* V16       										  *
\*****************************************************/

#include <stdint.h> // neu fuer standard integer Typen
#include <avr/io.h> // ios des Controllers
#include <avr/pgmspace.h> // routienen um aufs Flash zu schreiben usw.

#include <inttypes.h>
#include <stdlib.h> // fuer dtostrf()
#include <string.h> // fuer strcat()

#include "menue.h"
#include "lcd.h"

// Anzahl der Menue Eintraege im HauptMenue
#define MENUESIZE 7

// Daten Positon neben den Strings des Menues
#define DATAPOS 13

// Derzeit noch nicht in verwendung!!
// Display Groesse
#define XLCD 20
#define YLCD 4

/*	
Anz definiert wieviele Eintrge auf ein mal angezeigt werden, achtung
muss mindestens 1 sein und darf auch nicht groesser wie YLCD sein!
Wenn man zumBeispiel den Text auf der 1 Zeile haben will und die Daten
darunter dann Setzt man ANZ auf 1 und macht dann aber die Ausgabe der 
Daten selbst in den Funktionen die man dem Menue als Pointer uebergibt!
==> Also das Ganze ein wenig umschreiben!! 
*/
#define ANZ 4 


// Menue Struktur
typedef struct menue{
	char *text;
	int8_t previous; //menue vorher
	int8_t next; //naechstes menue
	char * (*fp) (void);
	//menueObject *sub; wiso ?? => geht das so nicht?
	struct menue *sub; //das ist doch eigentlich das gleiche oder ?
}menueObject;

//Benutzerdefinierter Sub Menues
struct menue mySUBM0[]PROGMEM = {
    {"-ESC-"   ,3, 1, NULL,NULL}, //0
	{"SUB 1:"  ,0, 2, NULL,NULL}, //1
	{"SUB 2:"  ,1, 3, function2,NULL}, //2
	{"SUB 3:"  ,2, 0, NULL,NULL}  //3
};

struct menue mySUBM1[]PROGMEM = {
    {"-ESC-"     ,2, 1, NULL,NULL}, //0
	{"SUB T1:"   ,0, 2, NULL,NULL}, //1
	{"SUB T2:"   ,1, 0, NULL,NULL}  //2
};

struct menue mySUBM2[]PROGMEM = {
    {"-ESC-"      ,7, 1, NULL,NULL}, //0
	{"STROM 1:"   ,0, 2, NULL,NULL}, //1
	{"STROM 2:"   ,1, 3, NULL,NULL}, //2
	{"SPG1:"      ,2, 4, function2,NULL}, //3
	{"SPG2:"      ,3, 5, function2,NULL}, //4
	{"SPG3:"      ,4, 6, NULL,NULL}, //5
	{"WIND:"      ,5, 7, NULL,NULL}, //6
	{"TEMP:"      ,6, 0, NULL,NULL}  //7
};

//Hier muss die Laenge der einzelnen Submenues angegeben 
//werden ==> ich weis nicht wie man die Laenge von dem 
//jeweiligen SubMenue sonst herrausbekommt!
int sublength[]={0,4,3,8}; //achtung reihenfolge beachten 
                           //siehe Beispiel!!

//Benutzerdefinierter HauptMenue Eintrag
menueObject myMenue[]PROGMEM = {
    {"TESTTESTTEST" , 6 ,1 ,function2 ,NULL},                   //0
	{"-SUBM1-"      , 0 ,2 ,function2 ,(menueObject*)mySUBM0},  //1
	{"-SUBM2TEST1-" , 1 ,3 ,function2 ,(menueObject*)mySUBM1},  //2
	{"-TEST-"       , 2 ,4 ,NULL ,(menueObject*)mySUBM2},       //3
	{"Kuhlschrank"  , 3 ,5 ,function2 ,NULL},                   //4
	{"Hallo Hallo"  , 4 ,6 ,NULL ,NULL},                        //5
	{"TEST END"     , 5 ,0 ,function2 ,NULL}                    //6
};

//aktuelle Cursor Positionen SUB und HauptMenue;
int8_t position;
int8_t positionSub;

//Daten fr das Menue ==> zum Beispiel Messdaten vom main.c
//oder sonst woher ==> mssen aber dann im menue.h mit extern 
//hinzugefgt werden!
uint16_t result;
int16_t spannung;

//Boolean im Submenu =>True oder im Hauptmenue =>False
BOOL menuePos;

// Anzeigen des Menues (eigentlich die Hauptseite)
void menue_show(void){

volatile int8_t i;
PGM_P text;

extern BOOL menuePos;
extern int8_t position;
extern menueObject myMenue[];	
//Funktionspointer auf die Menuefunktions des jeweiligen Eintrags
//Funktion bekommt nicht und gibt eine String mit den Daten zurck.
//Angezeigt werden diese auf der Position ==> DATAPOS 
char* (*myFunc)(void);

i = 0;
position = 0;
menuePos = FALSE;
							 	
lcd_clrscr();	
lcd_gotoxy(0,0);

for(i=0; i<ANZ;i++){
	text =  (PGM_P) pgm_read_word(&myMenue[i].text);
	lcd_puts(text);

	myFunc = (PGM_VOID_P) pgm_read_word(&myMenue[i].fp);
		
	if(myFunc != NULL){
		lcd_gotoxy(DATAPOS,i);
		lcd_puts(myFunc());
	}
	lcd_puts("\n");	
	}
}

/* Funktioniert so bis jetzt nicht schlecht!! */
void menue_update(void){

volatile int8_t i;
PGM_P text;
volatile int8_t temp;
volatile int8_t temp0;
volatile int8_t temp1;

extern int8_t position;
extern int8_t positionSub;
extern BOOL menuePos;

extern menueObject myMenue[];

char* (*myFunc)(void);   	

menueObject *mySubM;

lcd_clrscr();		
lcd_gotoxy(0,0);

lcd_command(LCD_DISP_ON_BLINK);

/* neu mit menuePos */
if(menuePos == TRUE){ //->wenn TRUE ==> Programm ist im SubMenue
   	//Aktuelle position vom Hauptmenue Merken!!
	temp0 = position;
   	//SubMenue lesen und Schauen obe auch eines vorhanden ist!!
	mySubM = (menueObject*)pgm_read_word(&myMenue[temp0].sub);
	//Uberpruefen ob wirklich im SubMenue!!
	if(mySubM != NULL){
		temp1 = positionSub;
		
		for(i=0; i<ANZ;i++){
			if(temp1 > (sublength[temp0]-1)) //sublength[temp0] ist die SubMenue groesse!!
				temp1 = 0;
	   		
	   		text = (PGM_P) pgm_read_word(&mySubM[temp1].text);
			lcd_puts(text);
			
			/* hier kommt noch der Code fr den Funktions aufruf 
			   der SubMenue eintraege!! */
			myFunc = (PGM_VOID_P) pgm_read_word(&mySubM[temp1].fp);
		
			if(myFunc != NULL){
				lcd_gotoxy(DATAPOS,i);
				lcd_puts(myFunc());
			}
			

			lcd_puts("\n");
	   		temp1 = temp1 + 1;
		}
  	}	
 }else if(menuePos==FALSE){
		temp = position;
		
		for(i=0; i<ANZ;i++){
			if(temp > (MENUESIZE-1))
				temp = 0;
		
			text =  (PGM_P) pgm_read_word(&myMenue[temp].text);
			lcd_puts(text);

	    	myFunc = (PGM_VOID_P) pgm_read_word(&myMenue[temp].fp);
		
			if(myFunc != NULL){
				lcd_gotoxy(DATAPOS,i);
				lcd_puts(myFunc());
			}
			lcd_puts("\n");
			temp = temp + 1;	
		}
	}
}

//scroll up => 0 und down => 1 uebergeben!!
void menue_scroll(uint8_t up0down1){
	
volatile int8_t i;
PGM_P text;
volatile int8_t temp;
volatile int8_t temp0;
volatile int8_t temp1;

extern int8_t position;
extern int8_t positionSub;
extern BOOL menuePos;
extern menueObject myMenue[]; 

char* (*myFunc)(void);   
	
menueObject *mySubM;

/* neu mit menuePos */

if(menuePos == TRUE){ //->wenn TRUE ==> Programm ist im SubMenue
	//Aktuelle position vom Hauptmenue Merken!!
	temp0 = position;	
    //SubMenue lesen und Schauen obe auch eines vorhanden ist!!
	mySubM = (menueObject*)pgm_read_word(&myMenue[temp0].sub);
	//Uberpruefen ob wirklich im SubMenue!!
	if(mySubM != NULL){
		if(up0down1){
			positionSub = pgm_read_byte(&mySubM[positionSub].next);
		}else positionSub = pgm_read_byte(&mySubM[positionSub].previous);
		
		temp1 = positionSub;
	   
		lcd_clrscr();
		lcd_gotoxy(0,0);
		lcd_command(LCD_DISP_ON_BLINK);
		
		for(i=0; i<ANZ;i++){
			if(temp1 > (sublength[temp0]-1)) //sublength[temp0] ist die SubMenue groesse!!
				temp1 = 0;

			text = (PGM_P) pgm_read_word(&mySubM[temp1].text);
			lcd_puts(text);

			/* hier kommt noch der Code fr den Funktions aufruf 
			   der SubMenue eintraege!! */
			myFunc = (PGM_VOID_P) pgm_read_word(&mySubM[temp1].fp);
		
			if(myFunc != NULL){
				lcd_gotoxy(DATAPOS,i);
				lcd_puts(myFunc());
			}
			
			
			lcd_puts("\n");
			temp1 = temp1 + 1;
	   	}
  	}
}else if(menuePos==FALSE){
		
	 	if(up0down1){
			position = pgm_read_byte(&myMenue[position].next);
		}else position = pgm_read_byte(&myMenue[position].previous);
		
		temp = position;
 		
 		//zugefuegt!!
		lcd_clrscr();
		lcd_gotoxy(0,0);
		lcd_command(LCD_DISP_ON_BLINK);

		for(i=0; i<ANZ;i++){
			if(temp > (MENUESIZE-1))
				temp = 0;
			
			text = (PGM_P) pgm_read_word(&myMenue[temp].text);
			lcd_puts(text);
		
			myFunc = (PGM_VOID_P) pgm_read_word(&myMenue[temp].fp);
		
			if(myFunc != NULL){
				lcd_gotoxy(DATAPOS,i);
				lcd_puts(myFunc());
			}
			
			lcd_puts("\n");									 
	    	temp = temp + 1;	
		}
	}
}

//subMenue_Enter
void subMenue_Enter(void){

volatile int8_t i;
volatile int8_t temp0;
volatile int8_t temp1;
PGM_P text;

extern int8_t position;
extern int8_t positionSub;
extern BOOL menuePos;
extern menueObject myMenue[];

char* (*myFunc)(void); 

menueObject *mySubM;
		
//Aktuelle position vom Hauptmenue fuers SubMenue holen!
temp0 = position;

//SubMenue lesen und Schauen obe auch eines vorhanden ist!!
mySubM = (menueObject*)pgm_read_word(&myMenue[temp0].sub);

if(menuePos == TRUE){
	//Position vom SubMenue holen!!
	temp1 = positionSub;
	text = (PGM_P) pgm_read_word(&mySubM[temp1].text);
	
	//wenn ESC gedrueckt SUBMenue verlassen!!
	if(strcmp(text,"-ESC-")==0){
   		menuePos = FALSE;
		menue_update();
	}
	
	// hier koennte man noch die BenutzerdefinierteFunktion aufrufen 
	// Beipiel irgedwas aus und einschalten im SUBMenue !!
	// fuer zum Beispiel eine Zahl erhoehen oder nicht!! oder so !!??

}else if(menuePos == FALSE) {
		if(mySubM != NULL){
			//jetzt im SUBMenue
			menuePos = TRUE;
			temp1 = 0; 

			lcd_clrscr();	
			lcd_gotoxy(0,0);
	
			for(i=0; i<ANZ;i++){
				if(temp1 > (sublength[temp0]-1))
					temp1 = 0; 
	   		
	   			text = (PGM_P) pgm_read_word(&mySubM[temp1].text);
				lcd_puts(text);
				   
				/* 	hier kommt noch der Code fr den Funktions aufruf 
			   		der SubMenue eintraege!! */
				
				myFunc = (PGM_VOID_P) pgm_read_word(&mySubM[temp1].fp);
		
				if(myFunc != NULL){
					lcd_gotoxy(DATAPOS,i);
					lcd_puts(myFunc());
				}

				lcd_puts("\n");
				temp1 = temp1 + 1;
			}

  		}else{
			// hier koennte man noch die BenutzerdefinierteFunktion aufrufen 
			// Beipiel irgedwas aus und einschalten im SUBMenue !!
			// fuer zum Beispiel eine Zahl erhoehen oder nicht!! oder so !!??
		}
	}
}

//Hier werden die Benutzerdefinierten Funktionen Ausgprogrammiert!!

char* function2(void){

	char tempBuf[15];
	float temp = 0;
	extern int16_t spannung;
	
	temp = spannung *(5./1024);

	dtostrf(temp, 5, 2, tempBuf ) ; 
	  
	return strcat(tempBuf,"V");
}

